# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class ActionBodyExecTemplate(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'action_definition_id': 'str',
        'params': 'object'
    }

    attribute_map = {
        'action_definition_id': 'actionDefinitionId',
        'params': 'params'
    }

    def __init__(self, action_definition_id=None, params=None, _configuration=None):  # noqa: E501
        """ActionBodyExecTemplate - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._action_definition_id = None
        self._params = None
        self.discriminator = None

        self.action_definition_id = action_definition_id
        if params is not None:
            self.params = params

    @property
    def action_definition_id(self):
        """Gets the action_definition_id of this ActionBodyExecTemplate.  # noqa: E501


        :return: The action_definition_id of this ActionBodyExecTemplate.  # noqa: E501
        :rtype: str
        """
        return self._action_definition_id

    @action_definition_id.setter
    def action_definition_id(self, action_definition_id):
        """Sets the action_definition_id of this ActionBodyExecTemplate.


        :param action_definition_id: The action_definition_id of this ActionBodyExecTemplate.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and action_definition_id is None:
            raise ValueError("Invalid value for `action_definition_id`, must not be `None`")  # noqa: E501

        self._action_definition_id = action_definition_id

    @property
    def params(self):
        """Gets the params of this ActionBodyExecTemplate.  # noqa: E501


        :return: The params of this ActionBodyExecTemplate.  # noqa: E501
        :rtype: object
        """
        return self._params

    @params.setter
    def params(self, params):
        """Sets the params of this ActionBodyExecTemplate.


        :param params: The params of this ActionBodyExecTemplate.  # noqa: E501
        :type: object
        """

        self._params = params

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ActionBodyExecTemplate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ActionBodyExecTemplate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ActionBodyExecTemplate):
            return True

        return self.to_dict() != other.to_dict()
